﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;
using System.Data;
using Infragistics.Windows;

namespace XamComboEditorDemo
{    
    public partial class Window1 : Window
    {
        /// <summary>
        /// Initializes a new instance of the SuggestionComboBoxSample class.
        /// </summary>
        public Window1()
        {
            InitializeComponent();

            DataTable dtData = new DataTable();
            dtData.Columns.Add("Field");
            dtData.Columns.Add("Label");
            dtData.Rows.Add(new object[] { "Field1", "Label1" });
            dtData.Rows.Add(new object[] { "Field2", "Label2" });
            dtData.Rows.Add(new object[] { "Field3", "Label3" });
            dtData.Rows.Add(new object[] { "Field4", "Label4" });
            dtData.Rows.Add(new object[] { "Field5", "Label5" });
            dtData.Rows.Add(new object[] { "Field6", "Label6" });
            dtData.Rows.Add(new object[] { "Field7", "Label7" });
            dtData.Rows.Add(new object[] { "Field8", "Label8" });
            dtData.Rows.Add(new object[] { "Field9", "Label9" });
            dtData.Rows.Add(new object[] { "Field10", "Label10" });
            dtData.Rows.Add(new object[] { "Field11", "Label11" });
            dtData.Rows.Add(new object[] { "Field12", "Label12" });
            dtData.Rows.Add(new object[] { "Field13", "Label13" });
            dtData.Rows.Add(new object[] { "Field14", "Label14" });
            dtData.Rows.Add(new object[] { "Field15", "Label15" });
            dtData.Rows.Add(new object[] { "Link Item", "Link Item" });

            cmbXamCombo.ItemsSource = dtData.DefaultView;
            //cmbXamCombo.DisplayMemberPath = "Label";
            cmbXamCombo.ValuePath = "Label";

            cmbXamCombo.Style = (Style)this.TryFindResource("ComboStyle");
        }

        private void cmbXamCombo_DropDownClosed(object sender, RoutedEventArgs e)
        {
            (sender as XamComboEditor).SelectedText = (sender as XamComboEditor).DisplayValue.ToString();
        }

        private void cmbXamCombo_DropDownOpened(object sender, RoutedEventArgs e)
        {
            if ((sender as XamComboEditor).DisplayValue != null)
            {
                (sender as XamComboEditor).SelectedText = (sender as XamComboEditor).DisplayValue.ToString();
            }
            
        }
        
    }

    public class TemplateSelector : DataTemplateSelector
    {
        public DataTemplate DefaultnDataTemplate { get; set; }
        public DataTemplate HyperLinkDataTemplate { get; set; }

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            XamComboEditor editor = Utilities.GetAncestorFromType(container, typeof(XamComboEditor), true) as XamComboEditor;
            DataView dv = editor.ItemsProvider.ItemsSource as DataView;
            if ((item as DataRowView).Row.ItemArray[1] == dv.Table.Rows[dv.Table.Rows.Count - 1].ItemArray[1])
            {
                //return App.Current.TryFindResource("hyperlinkTemplate") as DataTemplate;
                return HyperLinkDataTemplate;
            }
            //return App.Current.TryFindResource("regularTemplate") as DataTemplate;
            return DefaultnDataTemplate;
        }
    }

    public class ComboConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                return value;
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }
}
